# Running this function requires the following pre-requisites:
# - Target resource group and service principal are configured
# - Deployment configuration is filled in with all required values
# - Azure function app codebase is built and published into the zip file, zip file is available by the network file path
# - Folder with mapping files is available by the folder network path

#Create product-sync infrastructure and deploy Azure function
Write-Host "Deployment for product-sync azure resources started"
.\deploy-azure-resources.ps1 -deploymentConfigsPath "./configs/azure.productsync.stage.config.json" -zipArchivePath (Resolve-Path "./artifacts/zip/CHC.ProductSync.Api.zip") -mappingConfigsFolderPath "./artifacts/mappings/product-sync" -resourceName "productsync" -deleteResourceGroupItems $true -deployLogicApps $true
Write-Host "Deployment for product-sync azure resources completed"

#Create image-proxy infrastructure and deploy Azure function
Write-Host "Deployment for image-proxy azure resources started"
.\deploy-azure-resources.ps1 -deploymentConfigsPath "./configs/azure.imageproxy.stage.config.json" -zipArchivePath (Resolve-Path "./artifacts/zip/CHC.ImageProxy.zip") -mappingConfigsFolderPath "./artifacts/mappings/image-proxy" -resourceName "imageproxy" -deleteResourceGroupItems $false -deployLogicApps $false
Write-Host "Deployment for image-proxy azure resources completed"