function ConvertPSObjectToHashtable {
    param (
        [Parameter(ValueFromPipeline)]
        $InputObject
    )

    process {
        if ($null -eq $InputObject) { return $null }

        if ($InputObject -is [System.Collections.IEnumerable] -and $InputObject -isnot [string]) {
            $collection = @(
                foreach ($object in $InputObject) { ConvertPSObjectToHashtable $object }
            )

            Write-Output -NoEnumerate $collection
        }
        elseif ($InputObject -is [psobject]) {
            $hash = @{}

            foreach ($property in $InputObject.PSObject.Properties) {
                if ($property.TypeNameOfValue -eq "System.Management.Automation.PSCustomObject") {
                    $hash[$property.Name] = ConvertPSObjectToHashtable $property.Value
                }
                else {
                    $hash[$property.Name] = $property.Value
                }
            }

            $hash
        }
        else {
            @{}
        }
    }
}